(import tree-walkers simple-tests)

(verbose? #t)

(define-tester (iterate? lst '(0 1 2 3))
  (iterate cdr 2 lst)
  '(2 3)
  (iterate add1 5 1)
  6)

(define-tester (walk? flat '(0 1 2 3) deep '(0 (1 (2) 3) . 4))
  ((walk -1 2) flat)
  2
  ((walk 2) flat)
  '(2 3)
  ((walk 2) deep)
  4
  ((walk* 1 -1 1 -2) deep)
  2)

(test-all WALK iterate? walk?)
